// topword.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <Windows.h>
#include <vector>

#define BINTREE_SIZE 1024*1024				// ĴС
#define SORTBUFF_SIZE 1024*1024				// ڴĴС
#define HASHTABLE_SIZE 1100401			// ϣĴС
#define ALPHA_MAX 27				// ַܵ
#define CHARTAB_MAX 0xff			// ڴַӳ

int charidxtab[CHARTAB_MAX] = {0};		// ַ

void inittab()
{
	// ʼұ
	for(int i = 0; i < CHARTAB_MAX; i++ )
	{
		if( i >= 'a' && i <= 'z' )
			charidxtab[i] = i - 'a' + 1;
		else if( i >= 'A' && i <= 'Z' ) 
			charidxtab[i] = i - 'A' + 1;
		else charidxtab[i] = 0;
	}
}

char* filebuffer = NULL;
unsigned int filesize = 0;
int m,n;
int gFullBucketCount = 0, gHashConflictCount = 0;

struct node
{
	node():llink(NULL),rlink(NULL),pstr(NULL),len(0),count(0)
	{
	}
	
	unsigned short count;
	char *pstr;
	unsigned short len;
	node *llink;
	node *rlink;
};

node bintree[BINTREE_SIZE];//
int endofbintree = 0;

struct sortnode
{
	sortnode():pstr(NULL),len(0),count(0)
	{
	}
	
	unsigned short count;
	char *pstr;
	unsigned short len;
	sortnode* prev;
};

sortnode sortbuff[SORTBUFF_SIZE];//ڴ顣

struct resultnode
{
	resultnode():pstr(NULL),len(0),count(0)
	{
	}
	
	unsigned short count;
	char *pstr;
	unsigned short len;
};

resultnode *sortresult; //Ƶߵmڴ

struct hashitem
{
	hashitem()
		:pLink(NULL)
	{
	}
	
	node *pLink;
};

hashitem hashtable[HASHTABLE_SIZE];//ϣ

// һѭ
class loopqueue
{
	int queuelen;
	int curidx;
	int firstidx;
	char** pqueue;
public:
	loopqueue(int len)
	{
		queuelen = len+1;
		pqueue = (char**)malloc(sizeof(char*)*queuelen);
		curidx = 0;
		firstidx = 0;
	}
	~loopqueue()
	{
		delete pqueue;
	}
	void push(char*pstr)
	{
		pqueue[curidx++] = pstr;
		if(curidx==queuelen)curidx = 0;
	}
	void top_pop()
	{
		firstidx++;
		if( firstidx == queuelen )firstidx = 0;
	}
	char*  top()
	{
		return pqueue[firstidx];
	}
	
};

int cmpstr(char *str1, int &len1, char *str2, unsigned short &len2)//ַıȽ
{
	static int i;

	if(len1 == len2)
	{
		for(i = 0; i < len1; i ++)
		{
			if(charidxtab[*(str1+i)] > charidxtab[*(str2+i)])
			{
				return 1;
			}
			else if(charidxtab[*(str1+i)] < charidxtab[*(str2+i)])
			{
				return -1;
			}
		}

		return 0;
	}
	else if(len1 > len2)
	{
		return 1;
	}
	else
	{
		return -1;
	}
}


void Count()//
{
	char* buffend = filebuffer + filesize;
	char* currpos = filebuffer;
	int   spacenum = 0;
	char* str = NULL;
	int len;
	hashitem* item = NULL;
	unsigned int idx;
	int h;
	int cmpresult;
	node *pLink = NULL;
	node *pTmpLink = NULL;
	node *newnode = NULL;
	loopqueue lq(n);

	lq.push(filebuffer);

	while (currpos < buffend)
	{
		if( charidxtab[*currpos] == 0  )
		{
			spacenum++;
			lq.push(currpos+1);
			if( spacenum ==  n)
			{
				str = lq.top();
				len = currpos - str;
				
				//ҹϣ
				idx = 0;

				for(h=0;len-5 > -1 && h<len-5;h+=4)
				{
					idx *= 16777619;
					idx ^= *(int*)(str+h);
				}
				idx *= 16777619;
				idx ^= *(int*)(str+(len-4));
				idx %= HASHTABLE_SIZE;

				item = &hashtable[idx];

				if(item->pLink) //Ҷ
				{
					pLink = item->pLink;

					do
					{
						cmpresult = cmpstr(str,len,pLink->pstr,pLink->len);

						if(cmpresult == 0)
						{
							pLink->count ++;
							break;
						}
						else
						{
							pTmpLink = pLink;
							pLink = (cmpresult == -1)?pLink->llink:pLink->rlink;

							if(pLink == NULL)
							{
								gHashConflictCount ++;
								newnode = bintree + endofbintree;
								endofbintree ++;
								newnode->count = 1;
								newnode->pstr = str;
								newnode->len = len;
								if(cmpresult == -1)
									pTmpLink->llink = newnode;
								else
									pTmpLink->rlink = newnode;

								break;
							}
						}
					}while(pLink);
				}
				else
				{
					newnode = bintree + endofbintree;
					endofbintree ++;
					newnode->count = 1;
					newnode->pstr = str;
					newnode->len = len;
					item->pLink = newnode;
					gFullBucketCount ++;
				}

				spacenum--;
				lq.top_pop();
			}
			// ո
			currpos++;
			if( charidxtab[*currpos] == 0 && currpos < buffend )
			{
				while (charidxtab[*(currpos+1)] == 0 && currpos < buffend)
				{
					currpos++;
				}
			}
		}
		currpos ++;
	}
}

void GetTopM()//õǰM
{
	//bintree洢Ÿǵļ

	int endofresult = 0,nTop = 0,range,rangecount = 10,endofcursrtbuff = 0;
	float low = 1,up = 1,step;
	int itemcount[10]={0};
	sortnode *tail[10]={NULL};
	sortnode *currentsortbuff = sortbuff, *unsorttail = NULL;

	//ȰѼ1Ĵsortbuffȥ
	for(int i = 0,j = 0; i < endofbintree; i ++)
	{
		if(bintree[i].count > 1)
		{
			sortbuff[j].count = bintree[i].count;
			sortbuff[j].pstr = bintree[i].pstr;
			sortbuff[j].len = bintree[i].len;
			j ++;
			if(bintree[i].count > up) up = bintree[i].count;
		}
	}

	up = up + 0.01;

	//Ȼsortbuff

	step = (up - low)/rangecount;//ÿrangeĴС

	for(i = 0; i < j; i ++) //sortbuffĿֵ10rangeÿrangeڵĿ
	{
		range = (float(sortbuff[i].count) - low) / step;

		itemcount[range] ++;

		if(tail[range] == NULL)
		{
			tail[range] = &sortbuff[i];
			sortbuff[i].prev = NULL;
		}
		else
		{
			sortbuff[i].prev = tail[range];
			tail[range] = &sortbuff[i];
		}
	}

	while(endofresult < m)//range
	{
		for(i = rangecount - 1; i >= 0; i --)//range
		{
			nTop += itemcount[i];
			if(nTop < m)//ϵǰrangeĶmǰrangeĸȻһrange
			{
				while(tail[i])
				{
					sortresult[endofresult].count = tail[i]->count;
					sortresult[endofresult].pstr = tail[i]->pstr;
					sortresult[endofresult].len = tail[i]->len;
					endofresult ++;
					tail[i] = tail[i]->prev;
				}
			}
			else if(nTop == m)//ϵǰrangeĶmɹ
			{
				while(tail[i])
				{
					sortresult[endofresult].count = tail[i]->count;
					sortresult[endofresult].pstr = tail[i]->pstr;
					sortresult[endofresult].len = tail[i]->len;
					endofresult ++;
					tail[i] = tail[i]->prev;
				}

				return;
			}
			else//ϵǰrangeĶmforѭֵǰrange
			{
				nTop -= itemcount[i];
				low = low + step*i;
				up = low + step*(i+1) + 0.01;
				step = (up - low)/10;
				rangecount = 10;

				if(up - low < 1.011)//ǰrangeĴСΪ1СʹӵǰȡһЩmɹ
				{
					while(endofresult < m)
					{
						sortresult[endofresult].count = tail[i]->count;
						sortresult[endofresult].pstr = tail[i]->pstr;
						sortresult[endofresult].len = tail[i]->len;
						endofresult ++;
						tail[i] = tail[i]->prev;
					}

					return;
				}

				if(step < 1)
				{
					step = 1;
					rangecount = up - low + 0.99999999;
				}

				if(currentsortbuff == sortbuff)//ʹsortbuffbintreeΪǰڴ
					currentsortbuff = (sortnode *)bintree;
				else
					currentsortbuff = sortbuff;

				memset(currentsortbuff, 0, sizeof(sortnode)*itemcount[i]);
				endofcursrtbuff = 0;
				memset(itemcount, 0, sizeof(int)*10);
				unsorttail = tail[i];
				memset(tail,0,sizeof(sortnode *)*10);

				break;
			}
		}

		while(unsorttail)//
		{
			range = float(unsorttail->count - low) / step;

			itemcount[range] ++;

			currentsortbuff[endofcursrtbuff].count = unsorttail->count;
			currentsortbuff[endofcursrtbuff].pstr = unsorttail->pstr;
			currentsortbuff[endofcursrtbuff].len = unsorttail->len;

			if(tail[range] == NULL)
			{
				currentsortbuff[endofcursrtbuff].prev = NULL;
			}
			else
			{
				currentsortbuff[endofcursrtbuff].prev = tail[range];
			}

			tail[range] = &currentsortbuff[endofcursrtbuff];
			endofcursrtbuff ++;
			unsorttail = unsorttail->prev;

		}
	}
}


// ΢뼶ͳ
class Profile
{
public:
	Profile(const char* proname)
		:profilename(proname),llcount(0)
	{

	}
	void start()
	{
		QueryPerformanceCounter((LARGE_INTEGER*)&llstart);
	}
	void end()
	{
		LONGLONG llend;
		QueryPerformanceCounter((LARGE_INTEGER*)&llend);
		llcount += llend - llstart;
	}
	void display()
	{
		if( llFrequency == 0 )
		{
			QueryPerformanceFrequency((LARGE_INTEGER*)&llFrequency);
		}
		float totaltime = llcount;
		totaltime /= llFrequency;
		printf("Profile %s Total Time Use:%I64fs\n",profilename,totaltime);
	}
private:
	static LONGLONG llFrequency;
	LONGLONG llcount;
	LONGLONG llstart;
	const char* profilename;
};
LONGLONG Profile::llFrequency = 0;

Profile TopTimeTotal("ALL");

void usage()
{
	printf("Usage exe m n wordfile\n");
}


int main(int argc, char* argv[])
{
	TopTimeTotal.start();
	const char* file = NULL;
	if(argc != 4)
	{
		usage();
		return 0;
	}
	m = atoi(argv[1]);
	n = atoi(argv[2]);
	if( m == 0 || n == 0 )
	{
		usage();
		return 0;
	}
	file = argv[3];
	FILE * fp = fopen(file,"rb");
	if( fp == NULL )
	{
		printf("Can't Open file %s\n",file);
		return 0;
	}
	fpos_t fpos;
	
	fseek(fp,0,SEEK_END);
	fgetpos(fp,&fpos);
	fseek(fp,0,SEEK_SET);
	filesize = fpos;

	filebuffer = new char[filesize];
	if( filebuffer == NULL )
	{
		printf("No Memory\n");
		return 0;
	}
	int readsize;
	int lastsize = filesize;
	char* readbuff = filebuffer;
	while(lastsize > 0 )
	{
		readsize =  fread(readbuff,1,lastsize,fp);
		lastsize -= readsize;
		readbuff += readsize;
	}
	fclose(fp);

	inittab();

	sortresult = new resultnode[m];
	memset(sortresult, 0, sizeof(resultnode)*m);

	Count();//

	GetTopM();//õǰM



	TopTimeTotal.end();
	printf("\n------------result---------\n\n");
	for( int i = 0; i < m; i++ )
	{
		std::string szword(sortresult[i].pstr,sortresult[i].len);
		printf("[%s]:%d\n",szword.c_str(),sortresult[i].count);
	}

	printf("\n-- %d full bucket in hashtable\n",gFullBucketCount); 
	printf("-- %d word Conflicted while into table\n",gHashConflictCount); 

	printf("\n---------------------------------\n");

	TopTimeTotal.display();
	delete sortresult;
	delete filebuffer;

	return 0;
}
